package cn.yyxx.eyuangame.core.utils

import android.view.View
import kotlinx.coroutines.*
import kotlinx.coroutines.flow.*

/**
 * @author #Suyghur.
 * Created on 2022/02/15
 */

/**
 * 倒计时
 */
fun countDownCoroutines(total: Int, onTick: (Int) -> Unit, onFinish: () -> Unit, scope: CoroutineScope = GlobalScope): Job {
    return flow {
        for (i in total downTo 0) {
            emit(i)
            delay(1000)
        }
    }.flowOn(Dispatchers.Main)
        .onCompletion { onFinish.invoke() }
        .onEach { onTick.invoke(it) }
        .launchIn(scope)
}